package it.unitn.disi.ronchet.esame2207;

import it.unitn.disi.ronchet.esame2207.piastrelle.PiastrellaBase;
import it.unitn.disi.ronchet.esame2207.piastrelle.PiastrellaColorabile;
import it.unitn.disi.ronchet.esame2207.piastrelle.PiastrellaConInsertoRettangolare;
import it.unitn.disi.ronchet.esame2207.piastrelle.PiastrellaConInsertoTondo;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.scene.paint.Color;
import javafx.stage.Stage;

import java.io.IOException;

public class CatalogApp extends Application {
    public final static Palette basePalette=new Palette(); // la palette di colori per le piastrelle
    public final static Palette innerPalette=new Palette(); // palette di colori per gli inserti
    final ListaPiastrelle listaPiastrelle=new ListaPiastrelle();
    @Override
    public void start(Stage stage) throws IOException {
        // setup palettes
        basePalette.addColor(Color.LIGHTCYAN).addColor(Color.LIGHTPINK).addColor(Color.LEMONCHIFFON);
        innerPalette.addColor(Color.RED).addColor(Color.WHITE).addColor(Color.INDIGO).addColor(Color.GOLD);
        // genera le piastrelle e popola la lista
        createPiastrelle();

        BorderPane root=new BorderPane();
        PiastrellaBase p=listaPiastrelle.getCurrent();
        root.setCenter(p.getGrafica());
        root.setTop(p.printProperties());
        Button left=new Button("<");
        left.setOnAction(new EventHandler<ActionEvent>() {
                             @Override
                             public void handle(ActionEvent actionEvent) {
                                 PiastrellaBase bp=listaPiastrelle.getPrevious();
                                 root.setCenter(bp.getGrafica());
                                 root.setTop(bp.printProperties());
                             }
                         }
        );
        Button right=new Button(">");
        right.setOnAction(new EventHandler<ActionEvent>() {
                             @Override
                             public void handle(ActionEvent actionEvent) {
                                 PiastrellaBase bp=listaPiastrelle.getNext();
                                 root.setCenter(bp.getGrafica());
                                 root.setTop(bp.printProperties());
                             }
                         }
        );
        root.setRight(right);
        root.setLeft(left);
        Carrello carrello=new Carrello();
        Button acquista=new Button("acquista");
        acquista.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent actionEvent) {
                carrello.addItem(listaPiastrelle.getCurrent().printForCarrello());
            }
        });
        root.setBottom(acquista);
        BorderPane.setAlignment(acquista, Pos.BOTTOM_CENTER);
        Scene scene = new Scene(root, 320, 240);
        stage.setTitle("NOME COGNOME");
        stage.setScene(scene);
        stage.show();
    }

    private void createPiastrelle() {
        listaPiastrelle.add(new PiastrellaBase("N1",40,5,Materiale.CERAMICA));
        listaPiastrelle.add(new PiastrellaColorabile("C2",50,6,Materiale.TERRACOTTA));
        listaPiastrelle.add(new PiastrellaConInsertoRettangolare("B3",40,10,Materiale.LAMINATO));
        listaPiastrelle.add(new PiastrellaColorabile("C4",60,8,Materiale.CERAMICA));
        listaPiastrelle.add(new PiastrellaConInsertoTondo("B5",90,16,Materiale.CERAMICA));
    }

    public static void main(String[] args) {
        launch();
    }
}